// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AP51_PACKET_H)
#define AP51_PACKET_H

#ifndef bool
#define bool int
#define false 0
#define true  1
#endif

#define NULL    ((void *)0)

#if	!defined(FALSE) || (FALSE!=0)
#define FALSE   0
#endif

#if	!defined(TRUE) || (TRUE!=1)
#define TRUE    1
#endif

/* return status values */
#if	!defined(OK) || (OK!=0)
#define OK		0
#endif

#if	!defined(ERROR) || (ERROR!=(-1))
#define ERROR   (-1)
#endif

/* ACOS types */
#ifndef INT8
#define INT8    char
#endif

#ifndef INT16
#define INT16   short
#endif

#ifndef INT32
#define INT32   long
#endif

#ifndef UINT8
#define UINT8   unsigned char
#endif

#ifndef UNIT16
#define UINT16  unsigned short
#endif

#ifndef UNIT32
#define UINT32  unsigned int
#endif

#ifndef BOOL
#define BOOL    int
#endif

#ifndef STATUS
#define STATUS  int
#endif

#ifndef uint8
#define uint8 unsigned char
#endif

#ifndef uint16
#define uint16 unsigned int
#endif

#ifndef uint32
#define uint32 unsigned int
#endif

#define EQ ==
#define NEQ !=

#define FILES_CHKLEN_SIZE  4
#define FIELD_LEN_SIZE          4
#define FIELD_CHK_SIZE          4

#define FIELD_AMBIT_IDENTIFY    "*#$^"
#define FIELD_AMBIT_ID_PIPE "*#$^|"

#define MAX_SIZE_BOARDID 200
#define READ_BUFSZ 300

/*modified start, water, 10/30/2008, wnr3500u with 8M flash*/
/*#define MAX_SIZE_FILE 4*1024*1024
#define MAX_SIZE_KERNEL 4*1024*1024*/
#define MAX_SIZE_FILE 8*1024*1024
#define MAX_SIZE_KERNEL 8*1024*1024
/*modified end, water, 10/30/2008*/


#define MAX_FILENAME_LEN 100

#define LEN_VERSION 6 /* Jasmine, 10/25/2006 */
#define MINVAL(a, b) ((a) < (b) ? (a) : (b))

/* This image header is not completeness, it lack Board ID files */
typedef struct imageHdr_s
{
    unsigned char magic[4];     /* magic */
    unsigned char header_len[4];        /* Length of header */
    unsigned char reserved[8];
    unsigned char kernel_chksum[4];
    unsigned char rootfs_chksum[4];
    unsigned char kernel_len[4];        /* Length of kernel */
    unsigned char rootfs_len[4];        /* Length of rootfs */
    unsigned char image_chksum[4];      /* checksum across length of image */
    unsigned char header_chksum[4];     /* checksum across length of header */
} imageHdr_s;

typedef struct ImageInfo        /* Image information structure */
{
    unsigned long kernerlSize;
    unsigned long rootfsSize;
    unsigned long chksum;       /*checksum of image */
} ImageInfo_s;

extern unsigned long addHeader (char * board_id, char *bufPtr, char *kernelPtr, char *rootfsPtr,
                         UINT32 kernelSize, UINT32 rootfsSize);

#endif // !defined(AP51_PACKET_H)
